<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class UserRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
       $role = [NULL];
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role_id, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('users'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $request = request();
        $rules=[
            'photo' => 'sometimes',
            'name'=> 'required|min:3',
            'salary'=>'required',
            'gender'=>'required',
            'type'=>'required',
            'date_of_birth'=>'required',
            'branches'=>'required',
            'role_id'=>'required',
            'email' => [
                'required',
                'email',
                Rule::unique('users')->ignore($this->user? $this->user->id : 0, 'id')
               
            ],
            'phone'=> [
                "required",
                "numeric",
                "digits_between:11,14",
                Rule::unique('users')->ignore($this->user? $this->user->id : 0, 'id')
            ],
        ];

        if ( !$this->user  ) {
            $rules['password'] ='required|confirmed';
        } else {
            $rules['password'] ='sometimes|confirmed';
        }
        if($request->type == '1')
        {
        
           $rule=['result'=>'required'];
           $rules = array_merge($rules, $rule);    
        }
        
        

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        
        $attributes= [
            'name'=>  __('users.name'),
            'phone'=> __('users.phone'),
            'salary'=>  __('users.salary'),
            'email'=>  __('users.email'),
            'gender'=>  __('users.gender'),
            'type'=>  __('users.type'),
            'result'=>  __('users.result'),
            'date_of_birth'=>  __('users.date_of_birth'),
            'role_id'=>  __('users.role_id'),
            'photo'=>  __('users.photo'),
            'branches'=>  __('users.branch'),
            'password'=>  __('users.password'),
            'password_confirmation'=>  __('users.password_confirmation'),
            
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
